% Graphs.M %

% This program produces the graphs shown in
% "Testing for Linearity" by Bruce E. Hansen.
% For updates and contact information, see my webpage
% www.ssc.wisc.edu/~bhansen

load sun_k1.mat;
load sun_k2.mat;
load sun_k3.mat;
load ip_k1.mat;
load ip_k2.mat;
load ip_k3.mat;

load sunspotdat.txt;
ss=(sqrt(1+sunspotdat)-1)*2; 
n=length(ss);
xs=(1988-n):1987;
figure;
plot(xs,ss);
title('Figure 1: Annual Sunspot Means, 1700-1988');
grid on;

load ipdat.txt;
dat=log(ipdat);
dat=(dat(13:length(dat(:,1)))-dat(1:length(dat(:,1))-12))*100;
dat=dat(157:length(dat(:,1)));

xp=1960:(1/12):(1960+(length(dat(:,1))-1)/12);
figure;
plot(xp,dat);
title('Figure 2: U.S. Monthly Industrial Production/LAnnual Growth, 1960~1998');
grid on;

figure;
plot(sun_k1(:,1),sun_k1(:,2),sun_k1(:,1),sun_k1(:,3),sun_k1(:,1),sun_k1(:,4),sun_k1(:,1),sun_k1(:,5),sun_k1(:,1),sun_k1(:,6));
grid on;
title('Figure 3: Sunspot Series/LAsymptotic and Bootstrap Distributions of F(12)');
xlabel('Bootstrap Distributions of F(12)');
legend('Chi-Square(k)','Asymptotic (Homo.)','Bootstrap (Homo.)','Asymptotic (Hetero.)','Bootstrap (Hetero.)');

figure;
plot(ip_k1(:,1),ip_k1(:,2),ip_k1(:,1),ip_k1(:,3),ip_k1(:,1),ip_k1(:,4),ip_k1(:,1),ip_k1(:,5),ip_k1(:,1),ip_k1(:,6));
grid on;
title('Figure 4: Industrial Production/LAsymptotic and Bootstrap Distributions of F(12)');
xlabel('Bootstrap Distributions of F(12)');
legend('Chi-Square(k)','Asymptotic (Homo.)','Bootstrap (Homo.)','Asymptotic (Hetero.)','Bootstrap (Hetero.)');

figure;
plot(sun_k2(:,1),sun_k2(:,2),sun_k2(:,1),sun_k2(:,3),sun_k2(:,1),sun_k2(:,4));
grid on;
title('Figure 5: Sunspot Series/LAsymptotic and Bootstrap Distributions of F(13)');
legend('Chi-Square(2k)','Bootstrap (Homo.)','Bootstrap (Hetero.)');
xlabel('Bootstrap Distributions of F(13)');

figure;
plot(ip_k2(:,1),ip_k2(:,2),ip_k2(:,1),ip_k2(:,3),ip_k2(:,1),ip_k2(:,4));
grid on;
title('Figure 6: Industrial Production/LAsymptotic and Bootstrap Distributions of F(13)');
legend('Chi-Square(2k)','Bootstrap (Homo.)','Bootstrap (Hetero.)');
xlabel('Bootstrap Distributions of F(13)');

figure;
plot(sun_k3(:,1),sun_k3(:,2),sun_k3(:,1),sun_k3(:,3),sun_k3(:,1),sun_k3(:,4),sun_k3(:,1),sun_k3(:,5));
grid on;
title('Figure 7: Sunspot Series/LAsymptotic and Bootstrap Distributions of F(23)');
legend('Chi-Square(k)','Homoskedastic','Regime Hetero.','General Hetero.');
xlabel('Bootstrap Distributions of F(23)');

figure;
plot(ip_k3(:,1),ip_k3(:,2),ip_k3(:,1),ip_k3(:,3),ip_k3(:,1),ip_k3(:,4),ip_k3(:,1),ip_k3(:,5));
grid on;
title('Figure 8: Industrial Production/LAsymptotic and Bootstrap Distributions of F(23)');
legend('Chi-Square(k)','Homoskedastic','Regime Hetero.','General Hetero.');
xlabel('Bootstrap Distributions of F(23)');
